plugin.GetOptionsPanel = function(self)

	-- Create Options Panel --
	optionsPanel = Turbine.UI.Control();
	optionsPanel:SetSize(500, 370);


	-- Options title --
	optionsPanelTitle = Turbine.UI.Label();
	optionsPanelTitle:SetParent(optionsPanel);
	optionsPanelTitle:SetText("Settings");
	optionsPanelTitle:SetSize(400, 30);
	optionsPanelTitle:SetPosition(0, 25);
	optionsPanelTitle:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	optionsPanelTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	optionsPanelTitle:SetForeColor(Turbine.UI.Color.Yellow);
	optionsPanelTitle:SetFontStyle(Turbine.UI.FontStyle.Outline);
	optionsPanelTitle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	optionsPanelTitle:SetBackground(Turbine.UI.Graphic("HunterFocusDisplay/Images/optionsTitleBackground.tga"));


	-- Allow movement--
	option_allowMovement_label = Turbine.UI.Label();
	option_allowMovement_label:SetParent(optionsPanel);
	option_allowMovement_label:SetSize(300, 30);
	option_allowMovement_label:SetPosition(110, 70);
	option_allowMovement_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_allowMovement_label:SetText("Allow movement");
	option_allowMovement_label:SetForeColor(Turbine.UI.Color.White);
	option_allowMovement_checkbox = Turbine.UI.Lotro.CheckBox();
	option_allowMovement_checkbox:SetParent(optionsPanel);
	option_allowMovement_checkbox:SetSize(20, 20);
	option_allowMovement_checkbox:SetPosition(80, 69);
	option_allowMovement_checkbox:SetChecked(options["enableMovement"]);


	-- Display number --
	option_displayNumber_label = Turbine.UI.Label();
	option_displayNumber_label:SetParent(optionsPanel);
	option_displayNumber_label:SetSize(300, 30);
	option_displayNumber_label:SetPosition(110, 95);
	option_displayNumber_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_displayNumber_label:SetText("DisplayNumber");
	option_displayNumber_label:SetForeColor(Turbine.UI.Color.White);
	option_displayNumber_checkbox = Turbine.UI.Lotro.CheckBox();
	option_displayNumber_checkbox:SetParent(optionsPanel);
	option_displayNumber_checkbox:SetSize(20, 20);
	option_displayNumber_checkbox:SetPosition(80, 94);
	option_displayNumber_checkbox:SetChecked(options["displayNumber"]);


	-- Hide out of combat --
	option_hideOutOfCombat_label = Turbine.UI.Label();
	option_hideOutOfCombat_label:SetParent(optionsPanel);
	option_hideOutOfCombat_label:SetSize(300, 30);
	option_hideOutOfCombat_label:SetPosition(110, 120);
	option_hideOutOfCombat_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_hideOutOfCombat_label:SetText("Hide when out of combat");
	option_hideOutOfCombat_label:SetForeColor(Turbine.UI.Color.White);
	option_hideOutOfCombat_checkbox = Turbine.UI.Lotro.CheckBox();
	option_hideOutOfCombat_checkbox:SetParent(optionsPanel);
	option_hideOutOfCombat_checkbox:SetSize(20, 20);
	option_hideOutOfCombat_checkbox:SetPosition(80, 119);
	option_hideOutOfCombat_checkbox:SetChecked(options["hideOutOfCombat"]);


	-- FocusBarLenght --
	option_focusBarLenght_label = Turbine.UI.Label();
	option_focusBarLenght_label:SetParent(optionsPanel);
	option_focusBarLenght_label:SetSize(300, 30);
	option_focusBarLenght_label:SetPosition(80, 150);
	option_focusBarLenght_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_focusBarLenght_label:SetText("Bar Lenght");
	option_focusBarLenght_label:SetForeColor(Turbine.UI.Color.White);
	option_focusBarLenght_textbox = Turbine.UI.Lotro.TextBox();
	option_focusBarLenght_textbox:SetParent(optionsPanel);
	option_focusBarLenght_textbox:SetMultiline(false);
	option_focusBarLenght_textbox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_focusBarLenght_textbox:SetText(options["focusBarLenght"]);
	option_focusBarLenght_textbox:SetSize(100, 20);
	option_focusBarLenght_textbox:SetPosition(80, 170);
	option_focusBarLenght_textbox:SetZOrder(100);
	option_focusBarLenght_textbox.TextChanged = function (sender, args)
		-- Only allow numbers in textbox --
		option_focusBarLenght_textbox:SetText(option_focusBarLenght_textbox:GetText():gsub("[^0123456789]", ""));
	end


	-- FocusBarHeight --
	option_focusBarHeight_label = Turbine.UI.Label();
	option_focusBarHeight_label:SetParent(optionsPanel);
	option_focusBarHeight_label:SetSize(300, 30);
	option_focusBarHeight_label:SetPosition(80, 200);
	option_focusBarHeight_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_focusBarHeight_label:SetText("Bar Height");
	option_focusBarHeight_label:SetForeColor(Turbine.UI.Color.White);
	option_focusBarHeight_textbox = Turbine.UI.Lotro.TextBox();
	option_focusBarHeight_textbox:SetParent(optionsPanel);
	option_focusBarHeight_textbox:SetMultiline(false);
	option_focusBarHeight_textbox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_focusBarHeight_textbox:SetText(options["focusBarHeight"]);
	option_focusBarHeight_textbox:SetSize(100, 20);
	option_focusBarHeight_textbox:SetPosition(80, 220);
	option_focusBarHeight_textbox:SetZOrder(100);
	option_focusBarHeight_textbox.TextChanged = function (sender, args)
		-- Only allow numbers in textbox --
		option_focusBarHeight_textbox:SetText(option_focusBarHeight_textbox:GetText():gsub("[^0123456789]", ""));
	end


	-- FocusBarGap --
	option_focusBarGap_label = Turbine.UI.Label();
	option_focusBarGap_label:SetParent(optionsPanel);
	option_focusBarGap_label:SetSize(300, 30);
	option_focusBarGap_label:SetPosition(80, 250);
	option_focusBarGap_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_focusBarGap_label:SetText("Bar Gap");
	option_focusBarGap_label:SetForeColor(Turbine.UI.Color.White);
	option_focusBarGap_textbox = Turbine.UI.Lotro.TextBox();
	option_focusBarGap_textbox:SetParent(optionsPanel);
	option_focusBarGap_textbox:SetMultiline(false);
	option_focusBarGap_textbox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_focusBarGap_textbox:SetText(options["focusBarGap"]);
	option_focusBarGap_textbox:SetSize(100, 20);
	option_focusBarGap_textbox:SetPosition(80, 270);
	option_focusBarGap_textbox:SetZOrder(100);
	option_focusBarGap_textbox.TextChanged = function (sender, args)
		-- Only allow numbers in textbox --
		option_focusBarGap_textbox:SetText(option_focusBarGap_textbox:GetText():gsub("[^0123456789]", ""));
	end


	-- Apply options button --
	apllyButton = Turbine.UI.Lotro.Button();
	apllyButton:SetText("Apply");
	apllyButton:SetParent(optionsPanel);
	apllyButton:SetSize(150, 20);
	apllyButton:SetPosition(80, 330);
	apllyButton:SetZOrder(100);
	apllyButton.Click = function( sender, args)

		options["enableMovement"] = option_allowMovement_checkbox:IsChecked();
		FocusWindowClass.moveControl:SetMouseVisible(options["enableMovement"])

		options["hideOutOfCombat"] = option_hideOutOfCombat_checkbox:IsChecked();
		if (options["hideOutOfCombat"]) then
			FocusWindowClass.localPlayer.InCombatChanged();
		else
			FocusWindowClass:SetWantsUpdates(false)
			FocusWindowClass:SetOpacity(1)
		end

		options["displayNumber"] = option_displayNumber_checkbox:IsChecked();
		FocusWindowClass.Focus_label:SetVisible(options["displayNumber"])

		if (option_focusBarLenght_textbox:GetText() == "") then
			option_focusBarLenght_textbox:SetText("0")
		end

		if (option_focusBarHeight_textbox:GetText() == "") then
			option_focusBarHeight_textbox:SetText("0")
		end

		if (option_focusBarGap_textbox:GetText() == "") then
			option_focusBarGap_textbox:SetText("0")
		end

		options["focusBarLenght"] = option_focusBarLenght_textbox:GetText();
		options["focusBarHeight"] = option_focusBarHeight_textbox:GetText();
		options["focusBarGap"] = option_focusBarGap_textbox:GetText();

		FocusWindowClass:UpdateElements();

		notification("Options have been applied.");
	end

	
	-- Return View --
	return optionsPanel;
end